/* $File: //depot/main/ticWorkspaceGadget/src/WgInputServerFilter.h $
 * $Date: 2004/09/11 $
 * $Revision: #7 $
 *
 * (C) 1999-2004 by Mikael Jansson <apps@mikael.jansson.be>
 */
#ifndef WgInputServerFilter_h
#define WgInputServerFilter_h

#include <OS.h>
#include <InputServerFilter.h>
#include <Locker.h>
#include <Messenger.h>
#include <cstdio>

#include "WgGlobals.h"

#define T_MOUSE_SPEEDS 10
#define T_MOUSE_DIRECTION_VERTICAL		0
#define T_MOUSE_DIRECTION_HORIZONTAL 	1

class WgInputServerFilter : public BInputServerFilter {
public:
	WgInputServerFilter();
	~WgInputServerFilter();
	
	virtual filter_result Filter(BMessage *, BList *);
	virtual status_t InitCheck();
private:
	void LoadSettings();
	bool m_WarpingEnabled;
	int16 m_WarpingDelay;
	bool m_PopupEnabled;
	bool m_PopupAnimationEnabled;
	int16 m_PopupSize;
	int8 m_PopupPosition;
	int8 m_PopupDirection;

	BRect m_ScreenFrame;

	FILE *m_Fp;

	uint32 m_CurrentWorkspace;
	uint32 m_LastWorkspace;
	void RefreshStateIfNeeded();
	void StartPopupIfNeeded();
	BRect PopupFrame();
	void PopupMoveTo(float p_X, float p_Y);
	void SetPopupHidden(bool p_Hidden);
	bool MouseAtCorner(BPoint p_Point);
	bool MouseOutsidePopup(BPoint p_Point);
	void UpdateSpeed(BPoint, bigtime_t);
	void ChangeWorkspaceIfAttacked(BPoint);
	BPoint m_LastPoint;
	bigtime_t m_LastTime;
	double m_MouseSpeed;
	double m_LastSpeeds[T_MOUSE_SPEEDS];
	BPoint m_LastPoints[T_MOUSE_SPEEDS];
	uint8 m_MouseDirection;

	static int32 config_thread_function(void*);
	int32 ConfigThread();
	
	bool m_AppRunning;
	port_id m_CommPort;
	
	int m_CurrentSample;
	
	BMessenger *m_PopupMsgr;
	thread_id m_ConfigThread;
};

extern "C" _EXPORT BInputServerFilter* instantiate_input_filter();

#endif // WgInputServerFilter_h
