/* $File: //depot/main/ticWorkspaceGadget/src/WgPrefsWindow.h $
 * $Date: 2004/09/01 $
 * $Revision: #1 $
 *
 * (C) 1999-2004 by Mikael Jansson <apps@mikael.jansson.be>
 */
#ifndef WgPrefsWindow_h
#define WgPrefsWindow_h

#include "layout/MWindow.h"
#include "layout/MCheckBox.h"
#include "layout/SpinButton.h"
#include "layout/MRadioGroup.h"

#include <PopUpMenu.h>
#include <OS.h>

#define T_CURRENT_WORKSPACE 0
#define T_ALL_WORKSPACES 	1

class BMessage;

class WgPrefsWindow : public MWindow {
public:
	WgPrefsWindow(BRect);
	
	virtual bool QuitRequested();
	virtual void MessageReceived(BMessage*);
	virtual void WorkspacesChanged(uint32, uint32);
	virtual void WorkspaceActivated(int32, bool);

private:
	void SetWarpingEnabled(bool);
	void SetPopupEnabled(bool);
	void SetPopupAnimationEnabled(bool);
	
	void SetWarpingDelay(int);
	void SetPopupSize(int);

	void SetPopupPosition(int);
	void SetPopupDirection(int);

	void BroadcastChanges();

	void LoadSettings();
	BMessage *CurrentWorkspaceMessage();
	void SaveCurrentWorkspaceMessage(BMessage *);
	
	void SaveSettingsAllWorkspaces();


	BPopUpMenu *m_Workspaces;

	SpinButton *m_WarpingDelay;
	MCheckBox *m_WarpingEnabled;
	
	MCheckBox *m_PopupEnabled;
	MCheckBox *m_PopupAnimationEnabled;
	SpinButton *m_PopupSize;

	MRadioGroup *m_PopupPosition;
	MRadioGroup *m_PopupDirection;

	int m_Mode;
	
	port_id m_CommPort;
	
	int32 m_WorkspaceMessageIndex;

};

#endif // WgPrefsWindow_h
